/**
 */
package de.uks.se2.tfd.model;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.uks.se2.tfd.model.ModelFactory
 * @model kind="package"
 * @generated
 */
public interface ModelPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "model";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http:///de/uks/se2/tfd/model.ecore";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "de.uks.se2.tfd.model";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ModelPackage eINSTANCE = de.uks.se2.tfd.model.impl.ModelPackageImpl.init();

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.DiagramImpl <em>Diagram</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.DiagramImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getDiagram()
   * @generated
   */
  int DIAGRAM = 0;

  /**
   * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DIAGRAM__NODES = 0;

  /**
   * The feature id for the '<em><b>Edges</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DIAGRAM__EDGES = 1;

  /**
   * The number of structural features of the '<em>Diagram</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DIAGRAM_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.EdgeImpl <em>Edge</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.EdgeImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getEdge()
   * @generated
   */
  int EDGE = 1;

  /**
   * The feature id for the '<em><b>Diagrams</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EDGE__DIAGRAMS = 0;

  /**
   * The number of structural features of the '<em>Edge</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EDGE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.FlowImpl <em>Flow</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.FlowImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getFlow()
   * @generated
   */
  int FLOW = 2;

  /**
   * The feature id for the '<em><b>Diagrams</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW__DIAGRAMS = EDGE__DIAGRAMS;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW__NAME = EDGE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW__SOURCE = EDGE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW__TARGET = EDGE_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Flow</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_FEATURE_COUNT = EDGE_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.NodeImpl <em>Node</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.NodeImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getNode()
   * @generated
   */
  int NODE = 6;

  /**
   * The feature id for the '<em><b>Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NODE__DIAGRAM = 0;

  /**
   * The number of structural features of the '<em>Node</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NODE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.FlowNodeImpl <em>Flow Node</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.FlowNodeImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getFlowNode()
   * @generated
   */
  int FLOW_NODE = 3;

  /**
   * The feature id for the '<em><b>Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE__DIAGRAM = NODE__DIAGRAM;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE__NAME = NODE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Source Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE__SOURCE_FLOWS = NODE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Target Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE__TARGET_FLOWS = NODE_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Lane</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE__LANE = NODE_FEATURE_COUNT + 3;

  /**
   * The number of structural features of the '<em>Flow Node</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FLOW_NODE_FEATURE_COUNT = NODE_FEATURE_COUNT + 4;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.LaneImpl <em>Lane</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.LaneImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getLane()
   * @generated
   */
  int LANE = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE__NAME = 0;

  /**
   * The feature id for the '<em><b>Flow Nodes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE__FLOW_NODES = 1;

  /**
   * The feature id for the '<em><b>Variables</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE__VARIABLES = 2;

  /**
   * The feature id for the '<em><b>Lane Container</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE__LANE_CONTAINER = 3;

  /**
   * The number of structural features of the '<em>Lane</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.LaneContainerImpl <em>Lane Container</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.LaneContainerImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getLaneContainer()
   * @generated
   */
  int LANE_CONTAINER = 5;

  /**
   * The feature id for the '<em><b>Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_CONTAINER__DIAGRAM = NODE__DIAGRAM;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_CONTAINER__NAME = NODE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Variables</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_CONTAINER__VARIABLES = NODE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Lanes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_CONTAINER__LANES = NODE_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Lane Container</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LANE_CONTAINER_FEATURE_COUNT = NODE_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.StartImpl <em>Start</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.StartImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getStart()
   * @generated
   */
  int START = 7;

  /**
   * The feature id for the '<em><b>Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__DIAGRAM = FLOW_NODE__DIAGRAM;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__NAME = FLOW_NODE__NAME;

  /**
   * The feature id for the '<em><b>Source Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__SOURCE_FLOWS = FLOW_NODE__SOURCE_FLOWS;

  /**
   * The feature id for the '<em><b>Target Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__TARGET_FLOWS = FLOW_NODE__TARGET_FLOWS;

  /**
   * The feature id for the '<em><b>Lane</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__LANE = FLOW_NODE__LANE;

  /**
   * The number of structural features of the '<em>Start</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START_FEATURE_COUNT = FLOW_NODE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.TaskImpl <em>Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.TaskImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getTask()
   * @generated
   */
  int TASK = 8;

  /**
   * The feature id for the '<em><b>Diagram</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__DIAGRAM = FLOW_NODE__DIAGRAM;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__NAME = FLOW_NODE__NAME;

  /**
   * The feature id for the '<em><b>Source Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__SOURCE_FLOWS = FLOW_NODE__SOURCE_FLOWS;

  /**
   * The feature id for the '<em><b>Target Flows</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__TARGET_FLOWS = FLOW_NODE__TARGET_FLOWS;

  /**
   * The feature id for the '<em><b>Lane</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__LANE = FLOW_NODE__LANE;

  /**
   * The feature id for the '<em><b>Content</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__CONTENT = FLOW_NODE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_FEATURE_COUNT = FLOW_NODE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link de.uks.se2.tfd.model.impl.VariableImpl <em>Variable</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see de.uks.se2.tfd.model.impl.VariableImpl
   * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getVariable()
   * @generated
   */
  int VARIABLE = 9;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE__NAME = 0;

  /**
   * The feature id for the '<em><b>Lane Local</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE__LANE_LOCAL = 1;

  /**
   * The feature id for the '<em><b>Diagram1</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE__DIAGRAM1 = 2;

  /**
   * The number of structural features of the '<em>Variable</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE_FEATURE_COUNT = 3;


  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Diagram <em>Diagram</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Diagram</em>'.
   * @see de.uks.se2.tfd.model.Diagram
   * @generated
   */
  EClass getDiagram();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.Diagram#getNodes <em>Nodes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Nodes</em>'.
   * @see de.uks.se2.tfd.model.Diagram#getNodes()
   * @see #getDiagram()
   * @generated
   */
  EReference getDiagram_Nodes();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.Diagram#getEdges <em>Edges</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Edges</em>'.
   * @see de.uks.se2.tfd.model.Diagram#getEdges()
   * @see #getDiagram()
   * @generated
   */
  EReference getDiagram_Edges();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Edge <em>Edge</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Edge</em>'.
   * @see de.uks.se2.tfd.model.Edge
   * @generated
   */
  EClass getEdge();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.Edge#getDiagrams <em>Diagrams</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Diagrams</em>'.
   * @see de.uks.se2.tfd.model.Edge#getDiagrams()
   * @see #getEdge()
   * @generated
   */
  EReference getEdge_Diagrams();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Flow <em>Flow</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Flow</em>'.
   * @see de.uks.se2.tfd.model.Flow
   * @generated
   */
  EClass getFlow();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.Flow#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see de.uks.se2.tfd.model.Flow#getName()
   * @see #getFlow()
   * @generated
   */
  EAttribute getFlow_Name();

  /**
   * Returns the meta object for the reference '{@link de.uks.se2.tfd.model.Flow#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Source</em>'.
   * @see de.uks.se2.tfd.model.Flow#getSource()
   * @see #getFlow()
   * @generated
   */
  EReference getFlow_Source();

  /**
   * Returns the meta object for the reference '{@link de.uks.se2.tfd.model.Flow#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see de.uks.se2.tfd.model.Flow#getTarget()
   * @see #getFlow()
   * @generated
   */
  EReference getFlow_Target();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.FlowNode <em>Flow Node</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Flow Node</em>'.
   * @see de.uks.se2.tfd.model.FlowNode
   * @generated
   */
  EClass getFlowNode();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.FlowNode#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see de.uks.se2.tfd.model.FlowNode#getName()
   * @see #getFlowNode()
   * @generated
   */
  EAttribute getFlowNode_Name();

  /**
   * Returns the meta object for the reference list '{@link de.uks.se2.tfd.model.FlowNode#getSourceFlows <em>Source Flows</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Source Flows</em>'.
   * @see de.uks.se2.tfd.model.FlowNode#getSourceFlows()
   * @see #getFlowNode()
   * @generated
   */
  EReference getFlowNode_SourceFlows();

  /**
   * Returns the meta object for the reference list '{@link de.uks.se2.tfd.model.FlowNode#getTargetFlows <em>Target Flows</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Target Flows</em>'.
   * @see de.uks.se2.tfd.model.FlowNode#getTargetFlows()
   * @see #getFlowNode()
   * @generated
   */
  EReference getFlowNode_TargetFlows();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.FlowNode#getLane <em>Lane</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Lane</em>'.
   * @see de.uks.se2.tfd.model.FlowNode#getLane()
   * @see #getFlowNode()
   * @generated
   */
  EReference getFlowNode_Lane();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Lane <em>Lane</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Lane</em>'.
   * @see de.uks.se2.tfd.model.Lane
   * @generated
   */
  EClass getLane();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.Lane#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see de.uks.se2.tfd.model.Lane#getName()
   * @see #getLane()
   * @generated
   */
  EAttribute getLane_Name();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.Lane#getFlowNodes <em>Flow Nodes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Flow Nodes</em>'.
   * @see de.uks.se2.tfd.model.Lane#getFlowNodes()
   * @see #getLane()
   * @generated
   */
  EReference getLane_FlowNodes();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.Lane#getVariables <em>Variables</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Variables</em>'.
   * @see de.uks.se2.tfd.model.Lane#getVariables()
   * @see #getLane()
   * @generated
   */
  EReference getLane_Variables();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.Lane#getLaneContainer <em>Lane Container</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Lane Container</em>'.
   * @see de.uks.se2.tfd.model.Lane#getLaneContainer()
   * @see #getLane()
   * @generated
   */
  EReference getLane_LaneContainer();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.LaneContainer <em>Lane Container</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Lane Container</em>'.
   * @see de.uks.se2.tfd.model.LaneContainer
   * @generated
   */
  EClass getLaneContainer();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.LaneContainer#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see de.uks.se2.tfd.model.LaneContainer#getName()
   * @see #getLaneContainer()
   * @generated
   */
  EAttribute getLaneContainer_Name();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.LaneContainer#getVariables <em>Variables</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Variables</em>'.
   * @see de.uks.se2.tfd.model.LaneContainer#getVariables()
   * @see #getLaneContainer()
   * @generated
   */
  EReference getLaneContainer_Variables();

  /**
   * Returns the meta object for the containment reference list '{@link de.uks.se2.tfd.model.LaneContainer#getLanes <em>Lanes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Lanes</em>'.
   * @see de.uks.se2.tfd.model.LaneContainer#getLanes()
   * @see #getLaneContainer()
   * @generated
   */
  EReference getLaneContainer_Lanes();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Node <em>Node</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Node</em>'.
   * @see de.uks.se2.tfd.model.Node
   * @generated
   */
  EClass getNode();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.Node#getDiagram <em>Diagram</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Diagram</em>'.
   * @see de.uks.se2.tfd.model.Node#getDiagram()
   * @see #getNode()
   * @generated
   */
  EReference getNode_Diagram();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Start <em>Start</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Start</em>'.
   * @see de.uks.se2.tfd.model.Start
   * @generated
   */
  EClass getStart();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Task <em>Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Task</em>'.
   * @see de.uks.se2.tfd.model.Task
   * @generated
   */
  EClass getTask();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.Task#getContent <em>Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Content</em>'.
   * @see de.uks.se2.tfd.model.Task#getContent()
   * @see #getTask()
   * @generated
   */
  EAttribute getTask_Content();

  /**
   * Returns the meta object for class '{@link de.uks.se2.tfd.model.Variable <em>Variable</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Variable</em>'.
   * @see de.uks.se2.tfd.model.Variable
   * @generated
   */
  EClass getVariable();

  /**
   * Returns the meta object for the attribute '{@link de.uks.se2.tfd.model.Variable#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see de.uks.se2.tfd.model.Variable#getName()
   * @see #getVariable()
   * @generated
   */
  EAttribute getVariable_Name();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.Variable#getLaneLocal <em>Lane Local</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Lane Local</em>'.
   * @see de.uks.se2.tfd.model.Variable#getLaneLocal()
   * @see #getVariable()
   * @generated
   */
  EReference getVariable_LaneLocal();

  /**
   * Returns the meta object for the container reference '{@link de.uks.se2.tfd.model.Variable#getDiagram1 <em>Diagram1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Diagram1</em>'.
   * @see de.uks.se2.tfd.model.Variable#getDiagram1()
   * @see #getVariable()
   * @generated
   */
  EReference getVariable_Diagram1();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ModelFactory getModelFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.DiagramImpl <em>Diagram</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.DiagramImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getDiagram()
     * @generated
     */
    EClass DIAGRAM = eINSTANCE.getDiagram();

    /**
     * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DIAGRAM__NODES = eINSTANCE.getDiagram_Nodes();

    /**
     * The meta object literal for the '<em><b>Edges</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DIAGRAM__EDGES = eINSTANCE.getDiagram_Edges();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.EdgeImpl <em>Edge</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.EdgeImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getEdge()
     * @generated
     */
    EClass EDGE = eINSTANCE.getEdge();

    /**
     * The meta object literal for the '<em><b>Diagrams</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference EDGE__DIAGRAMS = eINSTANCE.getEdge_Diagrams();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.FlowImpl <em>Flow</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.FlowImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getFlow()
     * @generated
     */
    EClass FLOW = eINSTANCE.getFlow();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FLOW__NAME = eINSTANCE.getFlow_Name();

    /**
     * The meta object literal for the '<em><b>Source</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FLOW__SOURCE = eINSTANCE.getFlow_Source();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FLOW__TARGET = eINSTANCE.getFlow_Target();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.FlowNodeImpl <em>Flow Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.FlowNodeImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getFlowNode()
     * @generated
     */
    EClass FLOW_NODE = eINSTANCE.getFlowNode();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FLOW_NODE__NAME = eINSTANCE.getFlowNode_Name();

    /**
     * The meta object literal for the '<em><b>Source Flows</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FLOW_NODE__SOURCE_FLOWS = eINSTANCE.getFlowNode_SourceFlows();

    /**
     * The meta object literal for the '<em><b>Target Flows</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FLOW_NODE__TARGET_FLOWS = eINSTANCE.getFlowNode_TargetFlows();

    /**
     * The meta object literal for the '<em><b>Lane</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FLOW_NODE__LANE = eINSTANCE.getFlowNode_Lane();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.LaneImpl <em>Lane</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.LaneImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getLane()
     * @generated
     */
    EClass LANE = eINSTANCE.getLane();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LANE__NAME = eINSTANCE.getLane_Name();

    /**
     * The meta object literal for the '<em><b>Flow Nodes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LANE__FLOW_NODES = eINSTANCE.getLane_FlowNodes();

    /**
     * The meta object literal for the '<em><b>Variables</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LANE__VARIABLES = eINSTANCE.getLane_Variables();

    /**
     * The meta object literal for the '<em><b>Lane Container</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LANE__LANE_CONTAINER = eINSTANCE.getLane_LaneContainer();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.LaneContainerImpl <em>Lane Container</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.LaneContainerImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getLaneContainer()
     * @generated
     */
    EClass LANE_CONTAINER = eINSTANCE.getLaneContainer();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LANE_CONTAINER__NAME = eINSTANCE.getLaneContainer_Name();

    /**
     * The meta object literal for the '<em><b>Variables</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LANE_CONTAINER__VARIABLES = eINSTANCE.getLaneContainer_Variables();

    /**
     * The meta object literal for the '<em><b>Lanes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LANE_CONTAINER__LANES = eINSTANCE.getLaneContainer_Lanes();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.NodeImpl <em>Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.NodeImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getNode()
     * @generated
     */
    EClass NODE = eINSTANCE.getNode();

    /**
     * The meta object literal for the '<em><b>Diagram</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NODE__DIAGRAM = eINSTANCE.getNode_Diagram();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.StartImpl <em>Start</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.StartImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getStart()
     * @generated
     */
    EClass START = eINSTANCE.getStart();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.TaskImpl <em>Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.TaskImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getTask()
     * @generated
     */
    EClass TASK = eINSTANCE.getTask();

    /**
     * The meta object literal for the '<em><b>Content</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TASK__CONTENT = eINSTANCE.getTask_Content();

    /**
     * The meta object literal for the '{@link de.uks.se2.tfd.model.impl.VariableImpl <em>Variable</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see de.uks.se2.tfd.model.impl.VariableImpl
     * @see de.uks.se2.tfd.model.impl.ModelPackageImpl#getVariable()
     * @generated
     */
    EClass VARIABLE = eINSTANCE.getVariable();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIABLE__NAME = eINSTANCE.getVariable_Name();

    /**
     * The meta object literal for the '<em><b>Lane Local</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VARIABLE__LANE_LOCAL = eINSTANCE.getVariable_LaneLocal();

    /**
     * The meta object literal for the '<em><b>Diagram1</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VARIABLE__DIAGRAM1 = eINSTANCE.getVariable_Diagram1();

  }

} //ModelPackage
